/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-17 17:25
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const int MAXN = 2e5 + 5;
ll M, k, x ,y;

void solve(){
    // Code goes here ...
    cin >> M >> k >> x >> y;

    ll rem = M;
    ll maxy = M / k;
    ll taky = min(maxy, y);
    rem -= taky * k;
    /* cerr << rem << endl; */
    if(rem <= x){
        cout << 0 << endl;
        return;
    }

    ll remoy = rem - x;
    ll takyf = remoy / k;
    ll res = takyf + (remoy - takyf * k);

    if(rem - (takyf + 1) * k >= 0)
        ckmin(res, takyf + 1);

    /* fprintf(stderr, "%lld or %lld fancy big coins\n", takyf, takyf + 1); */
    /* fprintf(stderr, "%lld or %lld fancy sma coins\n", rem - takyf * k, (takyf + 1) * k - rem); */

    // ll res = min(abs(rem - takyf * k) + takyf, /*abs(rem - (takyf + 1) * k) +*/ takyf + 1);
    cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    return 0;
}
        
